package com.mycompany.blog.controller;

import java.util.List;

import org.springframework.boot.web.servlet.error.ErrorController;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.mycompany.blog.model.Entry;
import com.mycompany.blog.repo.EntryRepository;

@Controller
public class Maincontroller implements ErrorController
{
	private EntryRepository entryRepository;
	private List<Entry> all_entries;

	public Maincontroller(EntryRepository entryRepository)
	{
		this.entryRepository = entryRepository;
		this.all_entries = this.entryRepository.findAll(org.springframework.data.domain.Sort.by(org.springframework.data.domain.Sort.Order.desc("id")));
	}

	@GetMapping(path = { "", "/", "index" })
	public ModelAndView home()
	{
		ModelAndView modelAndView = new ModelAndView("index");
		modelAndView.addObject("entries", all_entries);
		return modelAndView;
	}

	@GetMapping(path = "entry")
	public ModelAndView entry(@RequestParam(name = "ent", required = true) Integer entry_id)
	{
		Entry entry = entryRepository.findById(entry_id).get();
		ModelAndView modelAndView = new ModelAndView("entry");
		modelAndView.addObject("entry", entry);
		modelAndView.addObject("content", "entries/" + entry_id + " :: " + entry_id + "");
		return modelAndView;
	}

	//	@GetMapping("/error")
	//	public String handleError(HttpServletRequest request)
	//	{
	//		Object status = request.getAttribute(RequestDispatcher.ERROR_STATUS_CODE);
	//		if (status != null)
	//		{
	//			Integer statusCode = Integer.valueOf(status.toString());
	//			if (statusCode == HttpStatus.NOT_FOUND.value())
	//			{
	//				return "error-404";
	//			}
	//			if (statusCode == HttpStatus.INTERNAL_SERVER_ERROR.value())
	//			{
	//				return "error-500";
	//			}
	//		}
	//		return "error-500";
	//	}
}
