package com.mycompany.blog.model;

import java.util.Date;
import java.util.List;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "ENTRY")
public class Entry
{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ID", nullable = false)
	private int id;

	@Column(name = "TITLE", nullable = false, length = 1500)
	private String title;

	@Column(name = "IMG_URL", nullable = false, length = 200)
	private String imgurl;

	@Column(name = "SUMMARY", nullable = false, length = 2000)
	private String summary;

	@ManyToOne
	@JoinColumn(name = "CAT", referencedColumnName = "ID", nullable = false)
	private Category category;

	@ManyToMany
	@JoinTable(name = "EntryTags", joinColumns = @JoinColumn(name = "entryId"), inverseJoinColumns = @JoinColumn(name = "tagId"))
	private List<Tag> tags;

	@Column(name = "PUB_DATE", nullable = false)
	private Date publishDate = new Date();

	public Entry()
	{
	}

	public Entry(int id, String title, String imgurl, String summary, Category category, List<Tag> tags, Date publishDate)
	{
		this.id = id;
		this.title = title;
		this.imgurl = imgurl;
		this.summary = summary;
		this.category = category;
		this.tags = tags;
		this.publishDate = publishDate;
	}

	public int getId()
	{
		return id;
	}

	public void setId(int id)
	{
		this.id = id;
	}

	public String getTitle()
	{
		return title;
	}

	public void setTitle(String title)
	{
		this.title = title;
	}

	public String getImgurl()
	{
		return imgurl;
	}

	public void setImgurl(String imgurl)
	{
		this.imgurl = imgurl;
	}

	public String getSummary()
	{
		return summary;
	}

	public void setSummary(String summary)
	{
		this.summary = summary;
	}

	public Category getCategory()
	{
		return category;
	}

	public void setCategory(Category category)
	{
		this.category = category;
	}

	public List<Tag> getTags()
	{
		return tags;
	}

	public void setTags(List<Tag> tags)
	{
		this.tags = tags;
	}

	public Date getPublishDate()
	{
		return publishDate;
	}

	public void setPublishDate(Date publishDate)
	{
		this.publishDate = publishDate;
	}
}
