package com.mycompany.blog.model;

import java.util.List;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.OrderBy;
import jakarta.persistence.Table;

@Entity
@Table(name = "TAG")
public class Tag
{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ID", nullable = false)
	private int id;

	@Column(name = "NAME", nullable = false, length = 100)
	private String name;

	@ManyToMany(mappedBy = "tags")
	@OrderBy(value = "id desc")
	private List<Entry> entries;

	public Tag()
	{
	}

	public Tag(int id, String name, List<Entry> entries)
	{
		this.id = id;
		this.name = name;
		this.entries = entries;
	}

	public int getId()
	{
		return id;
	}

	public void setId(int id)
	{
		this.id = id;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public void setEntries(List<Entry> entries)
	{
		this.entries = entries;
	}
}
